#Reset the field
kill @e[tag=Generation]
kill @e[name=RetreatPos]
kill @e[name=ReturnSpot2]
scoreboard players set CountRoom Generation 0
scoreboard players set CountHallway Generation 0
scoreboard players set MaxCount Generation 0
fill -64 26 -64 63 27 63 air
fill -64 28 -64 63 29 63 air
fill -64 25 -64 63 25 63 black_concrete
execute as @a run trigger TriggerCutscene set 0
scoreboard players set @a TriggerCutscene 0
scoreboard players set Running Cutscene 0
scoreboard players set Timer Cutscene 0

#Starting room
summon armor_stand -8.0 26 -8.0 {CustomName:"\"Room\"",Tags:["Generation"],CustomNameVisible:0}

#Generate new rooms and hallways
execute as @e[type=armor_stand,limit=1,sort=random,tag=Generation] at @s if score EndRoom Generation >= CountRoom Generation run function generate:shaft/newroom

#Set the hallway paths
scoreboard players set @e[type=armor_stand,name=Hallway] Math 0
execute as @e[type=armor_stand,limit=1,sort=random,name=Hallway] at @s run function generate:shaft/hallway
execute as @e[type=armor_stand,limit=1,sort=random,name=Room] at @s run function generate:shaft/room

#Correct lonely hallways
scoreboard players set @e[type=armor_stand,name=Hallway] Math 0
execute as @e[type=armor_stand,name=Hallway] at @s run function generate:shaft/hallway2

#Remove triple or quadruple hallways
scoreboard players set @e[type=armor_stand,name=Hallway] Math 0
execute as @e[type=armor_stand,name=Hallway] at @s if block ~4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~-4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~ ~ ~4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~ ~ ~-4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway,scores={Math=3..4}] at @s unless entity @s[tag=X1Invalid,tag=X2Invalid,tag=Y1Invalid,tag=Y2Invalid] run function generate:shaft/hallway3
execute as @e[type=armor_stand,name=Hallway,scores={Math=3..4}] at @s unless entity @s[tag=X1Invalid,tag=X2Invalid,tag=Y1Invalid,tag=Y2Invalid] run function generate:shaft/hallway3
execute as @e[type=armor_stand,name=Hallway,scores={Math=3..4}] at @s unless entity @s[tag=X1Invalid,tag=X2Invalid,tag=Y1Invalid,tag=Y2Invalid] run function generate:shaft/hallway3
execute as @e[type=armor_stand,name=Hallway,scores={Math=3..4}] at @s unless entity @s[tag=X1Invalid,tag=X2Invalid,tag=Y1Invalid,tag=Y2Invalid] run function generate:shaft/hallway3

#Any forced single, triple or quadruple hallway becomes a room
scoreboard players set @e[type=armor_stand,name=Hallway] Math 0
execute as @e[type=armor_stand,name=Hallway] at @s if block ~4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~-4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~ ~ ~4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway] at @s if block ~ ~ ~-4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Hallway,scores={Math=3..4}] run data merge entity @s {CustomName:"\"Room\""}
execute as @e[type=armor_stand,name=Hallway,scores={Math=1}] run data merge entity @s {CustomName:"\"Room\""}

#Any loose strings are deleted
execute as @e[tag=Generation] at @s if block ~7 ~ ~ red_wool positioned ~16 ~ ~ unless entity @e[tag=Generation,distance=..2] at @s run fill ~16 ~ ~ ~ ~ ~ air replace red_wool
execute as @e[tag=Generation] at @s if block ~-7 ~ ~ red_wool positioned ~-16 ~ ~ unless entity @e[tag=Generation,distance=..2] at @s run fill ~-16 ~ ~ ~ ~ ~ air replace red_wool
execute as @e[tag=Generation] at @s if block ~ ~ ~7 red_wool positioned ~ ~ ~16 unless entity @e[tag=Generation,distance=..2] at @s run fill ~ ~ ~16 ~ ~ ~ air replace red_wool
execute as @e[tag=Generation] at @s if block ~ ~ ~-7 red_wool positioned ~ ~ ~-16 unless entity @e[tag=Generation,distance=..2] at @s run fill ~ ~ ~-16 ~ ~ ~ air replace red_wool

#50% of the double rooms becomes a hallway
scoreboard players set @e[type=armor_stand,name=Room] Math 0
execute as @e[type=armor_stand,name=Room] at @s if block ~4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Room] at @s if block ~-4 ~ ~ red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Room] at @s if block ~ ~ ~4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Room] at @s if block ~ ~ ~-4 red_wool run scoreboard players add @s Math 1
execute as @e[type=armor_stand,name=Room,scores={Math=2}] run function generate:shaft/doubleroom

#Any room only connected directly to 1 room is deleted
execute unless score MissionLocation Mission matches 2 run function generate:deletelone
execute if score MissionLocation Mission matches 3 run function generate:deletelone
execute if score MissionLocation Mission matches 3 run function generate:deletelone

#Set up the room visuals/enemies
execute at @e[type=armor_stand,name=Room] run fill ~5 ~ ~5 ~-6 ~ ~-6 stone
execute at @e[type=armor_stand,name=Hallway] run fill ~2 ~ ~2 ~-3 ~ ~-3 stone
function generate:roomdeco

#Set up the hallway visuals/enemies
execute as @e[name=Hallway] at @s run function generate:hallwaydeco
kill @e[name=Hallway]

#Set up the party
##Marker
execute at @e[tag=StartRoom] run tp @e[name=WalkMarker] ~ ~1 ~
execute at @e[tag=StartRoom] run fill ~ ~1 ~ ~-1 ~1 ~-1 white_concrete
execute at @e[tag=StartRoom] run setblock ~1 ~1 ~1 white_concrete
execute at @e[tag=StartRoom] run setblock ~1 ~1 ~-2 white_concrete
execute at @e[tag=StartRoom] run setblock ~-2 ~1 ~1 white_concrete
execute at @e[tag=StartRoom] run setblock ~-2 ~1 ~-2 white_concrete
kill @e[type=armor_stand,name=RetreatPos]
kill @e[name=RetreatPosPlayer]
execute at @e[name=WalkMarker] run summon armor_stand ~ ~ ~ {CustomName:"\"RetreatPos\"",Tags:["Generation","RoomRetreat"],Invisible:1,Marker:1}

##Tags
tag @e[tag=SelectTeam] remove LobbyTalker
tag @e[tag=SelectTeam] remove LobbyTrader
execute as @e[tag=SelectTeam] run data merge entity @s {NoAI:1,Rotation:[-90.0,0.0]}
execute as @e[tag=SelectTeam] at @s run tp @s ~ ~ ~ -90 0
tag @e[tag=SelectTeam] add Player
tag @e[tag=SelectTeam] add InField
tag @e[tag=SelectTeam] remove SelectTeam
tag @a[tag=Playing] remove Lobby
tag @a[tag=Playing] add InDungeon
clear @a[tag=Playing] #main:character
clear @a[tag=Playing,tag=!Dev] written_book
team join Player @e[tag=Player]
tag @e[tag=Player,limit=1,sort=random] add LastActed
tag @e[tag=StartRoom] add Entered

team join Warrior @e[name=Warrior,tag=Player] 
team join Mage @e[name=Mage,tag=Player] 
team join Thief @e[name=Thief,tag=Player] 
team join Blaze @e[name=Blaze,tag=Player] 
team join Spirit @e[name=Spirit,tag=Player] 
team join Evoker @e[name=Evoker,tag=Player] 
team join Angel @e[name=Angel,tag=Player] 
team join Demon @e[name=Demon,tag=Player] 
team join Reaper @e[name=Reaper,tag=Player] 

#Stats
scoreboard players set @e[name=Warrior] ClassType 1
scoreboard players set @e[name=Mage] ClassType 2
scoreboard players set @e[name=Thief] ClassType 3
scoreboard players set @e[name=Blaze] ClassType 4
scoreboard players set @e[name=Spirit] ClassType 5
scoreboard players set @e[name=Evoker] ClassType 6
scoreboard players set @e[name=Angel] ClassType 7
scoreboard players set @e[name=Demon] ClassType 8
scoreboard players set @e[name=Reaper] ClassType 9
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Attack = @s Attack
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Defense = @s Defense
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Speed = @s Speed
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Dodge = @s Dodge
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Accuracy = @s Accuracy
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] MaxHealth = @s MaxHealth
execute as @e[tag=Player] run scoreboard players operation @s Health = @s MaxHealth

scoreboard players set @e[tag=Player,name=Morro] Attack 6
scoreboard players set @e[tag=Player,name=Morro] Defense 0
scoreboard players set @e[tag=Player,name=Morro] Speed 3
scoreboard players set @e[tag=Player,name=Morro] Dodge 20
scoreboard players set @e[tag=Player,name=Morro] Accuracy 110
scoreboard players set @e[tag=Player,name=Morro] MaxHealth 20
scoreboard players set @e[tag=Player,name=Morro] Health 20
scoreboard players set @e[tag=Player,name=Morro] FireResist 70
scoreboard players set @e[tag=Player,name=Morro] PoisonResist 50
scoreboard players set @e[tag=Player,name=Morro] StunResist 30

scoreboard players set @e[tag=Player] SkillTotal 0
scoreboard players set @e[tag=Player] GearTotal 0
scoreboard players set @e[tag=Player] EffectProtection 0
scoreboard players set @e[tag=Player] EffectStealth 0
scoreboard players set @e[tag=Player] EffectUndying 0
scoreboard players set @e[tag=Player] EffectBlessed 0
scoreboard players set @e[tag=Player] EffectMark 0

execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Skill1 = @s Skill1
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Skill2 = @s Skill2
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Skill3 = @s Skill3
execute as @e[tag=Player] if score @s Skill1 matches 1.. if score @s Skill2 matches 1.. if score @s Skill3 matches 1.. run scoreboard players set @s SkillTotal 10
execute as @e[tag=Player] if score @s Skill1 matches 2.. if score @s Skill2 matches 2.. if score @s Skill3 matches 2.. run scoreboard players set @s SkillTotal 20
execute as @e[tag=Player] if score @s Skill1 matches 3.. if score @s Skill2 matches 3.. if score @s Skill3 matches 3.. run scoreboard players set @s SkillTotal 30
execute as @e[tag=Player] if score @s Skill1 matches 4.. if score @s Skill2 matches 4.. if score @s Skill3 matches 4.. run scoreboard players set @s SkillTotal 40
execute as @e[tag=Player] if score @s Skill1 matches 5.. if score @s Skill2 matches 5.. if score @s Skill3 matches 5.. run scoreboard players set @s SkillTotal 50
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] FireResist = @s FireResist
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] PoisonResist = @s PoisonResist
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] StunResist = @s StunResist
execute as @e[tag=Player] run scoreboard players operation @s FireResist += @s SkillTotal
execute as @e[tag=Player] run scoreboard players operation @s PoisonResist += @s SkillTotal
execute as @e[tag=Player] run scoreboard players operation @s StunResist += @s SkillTotal

execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Gear1 = @s Gear1
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Gear2 = @s Gear2
execute as @e[tag=Player] at @s as @e[type=armor_stand,tag=ClassStats] if score @s ClassType = @e[tag=Player,distance=..1,limit=1] ClassType run scoreboard players operation @e[tag=Player,distance=..1] Gear3 = @s Gear3
execute as @e[tag=Player] if score @s Gear1 matches 1.. if score @s Gear2 matches 1.. if score @s Gear3 matches 1.. run scoreboard players set @s GearTotal 10
execute as @e[tag=Player] if score @s Gear1 matches 2.. if score @s Gear2 matches 2.. if score @s Gear3 matches 2.. run scoreboard players set @s GearTotal 20
execute as @e[tag=Player] if score @s Gear1 matches 3.. if score @s Gear2 matches 3.. if score @s Gear3 matches 3.. run scoreboard players set @s GearTotal 30
execute as @e[tag=Player] if score @s Gear1 matches 4.. if score @s Gear2 matches 4.. if score @s Gear3 matches 4.. run scoreboard players set @s GearTotal 40
execute as @e[tag=Player] if score @s Gear1 matches 5.. if score @s Gear2 matches 5.. if score @s Gear3 matches 5.. run scoreboard players set @s GearTotal 50

scoreboard players set @e[tag=Player] Food 0

#Fear
execute unless entity @e[name=Warrior,tag=Player] run scoreboard players remove @e[name=WarriorStats] Fear 5
execute unless entity @e[name=Mage,tag=Player] run scoreboard players remove @e[name=MageStats] Fear 5
execute unless entity @e[name=Thief,tag=Player] run scoreboard players remove @e[name=ThiefStats] Fear 5
execute unless entity @e[name=Blaze,tag=Player] run scoreboard players remove @e[name=BlazeStats] Fear 5
execute unless entity @e[name=Spirit,tag=Player] run scoreboard players remove @e[name=SpiritStats] Fear 5
execute unless entity @e[name=Evoker,tag=Player] run scoreboard players remove @e[name=EvokerStats] Fear 5
execute unless entity @e[name=Angel,tag=Player] run scoreboard players remove @e[name=AngelStats] Fear 5
execute unless entity @e[name=Demon,tag=Player] run scoreboard players remove @e[name=DemonStats] Fear 5
execute unless entity @e[name=Reaper,tag=Player] run scoreboard players remove @e[name=ReaperStats] Fear 5
execute as @e[tag=ClassStats] if score @s Fear matches ..-1 run scoreboard players set @s Fear 0

scoreboard players set Fear Math 0
execute if entity @e[tag=Player,name=Warrior] run scoreboard players operation Fear Math += @e[name=WarriorStats] FearReal
execute if entity @e[tag=Player,name=Mage] run scoreboard players operation Fear Math += @e[name=MageStats] FearReal
execute if entity @e[tag=Player,name=Thief] run scoreboard players operation Fear Math += @e[name=ThiefStats] FearReal
execute if entity @e[tag=Player,name=Blaze] run scoreboard players operation Fear Math += @e[name=BlazeStats] FearReal
execute if entity @e[tag=Player,name=Spirit] run scoreboard players operation Fear Math += @e[name=SpiritStats] FearReal
execute if entity @e[tag=Player,name=Evoker] run scoreboard players operation Fear Math += @e[name=EvokerStats] FearReal
execute if entity @e[tag=Player,name=Angel] run scoreboard players operation Fear Math += @e[name=AngelStats] FearReal
execute if entity @e[tag=Player,name=Demon] run scoreboard players operation Fear Math += @e[name=DemonStats] FearReal
execute if entity @e[tag=Player,name=Reaper] run scoreboard players operation Fear Math += @e[name=ReaperStats] FearReal
bossbar set minecraft:fear visible true
bossbar set minecraft:fear players @a[tag=Playing]
execute store result bossbar minecraft:fear value run scoreboard players get Fear Math
scoreboard objectives setdisplay sidebar

fill -18 4 -36 -30 20 -36 air
bossbar set minecraft:fear name ["",{"text":"Fear: "},{"score":{"name":"Fear","objective":"Math"}}]

#Set up the mission
scoreboard players set ObjNow Mission 0
scoreboard players set ObjGoal Mission 0
execute if score MissionType Mission matches 1 as @e[name=Enemy,type=armor_stand] at @s if block ~ ~-1 ~ #main:room run scoreboard players add ObjGoal Mission 1
execute if score MissionType Mission matches 2 run scoreboard players set ObjGoal Mission 1
execute if score MissionType Mission matches 3 as @e[name=Room,type=armor_stand] run scoreboard players add ObjGoal Mission 1
execute if score MissionType Mission matches 3 run scoreboard players operation ObjGoal Mission *= Base4 Math
execute if score MissionType Mission matches 3 run scoreboard players operation ObjGoal Mission /= Base5 Math
execute if score MissionType Mission matches 4 run scoreboard players set ObjGoal Mission 3
execute if score MissionType Mission matches 5 run scoreboard players set ObjGoal Mission 1
execute if score MissionType Mission matches 7 run scoreboard players set ObjGoal Mission 1

#Load the starting room
execute at @e[name=WalkMarker] run setblock ~ 25 ~ green_concrete
execute if score MissionLocation Mission matches 1 run clone -64 15 32 -50 19 28 -31 3 -35
execute if score MissionLocation Mission matches 2 run clone -64 15 14 -50 19 10 -31 3 -35
execute if score MissionLocation Mission matches 3 run clone -64 15 -4 -50 19 -8 -31 3 -35
execute if score MissionLocation Mission matches 4 run clone -64 15 -22 -50 19 -26 -31 3 -35
execute positioned 4 10 16 run tp @e[tag=Player,limit=1,sort=furthest,distance=..10] -26 4 -34
execute positioned 4 10 16 run tp @e[tag=Player,limit=1,sort=furthest,distance=..10] -28 4 -34
execute positioned 4 10 16 run tp @e[tag=Player,limit=1,sort=furthest,distance=..10] -30 4 -34

#Relics
data remove storage fight:ztemp List
data remove storage fight:pos1 List
data remove storage fight:pos2 List
data remove storage fight:pos3 List
data remove storage fight:pos1e List
data remove storage fight:pos2e List
data remove storage fight:pos3e List
execute positioned -41 4 -34 run tag @e[tag=Player,limit=1,sort=furthest] add Pos1
execute positioned -41 4 -34 run tag @e[tag=Player,limit=1,sort=furthest,tag=!Pos1] add Pos2
execute positioned -41 4 -34 run tag @e[tag=Player,limit=1,sort=furthest,tag=!Pos1,tag=!Pos2] add Pos3
execute as @e[tag=Player,name=Warrior] run scoreboard players operation @s Relic = @e[name=WarriorStats] Relic
execute as @e[tag=Player,name=Mage] run scoreboard players operation @s Relic = @e[name=MageStats] Relic
execute as @e[tag=Player,name=Thief] run scoreboard players operation @s Relic = @e[name=ThiefStats] Relic
execute as @e[tag=Player,name=Blaze] run scoreboard players operation @s Relic = @e[name=BlazeStats] Relic
execute as @e[tag=Player,name=Spirit] run scoreboard players operation @s Relic = @e[name=SpiritStats] Relic
execute as @e[tag=Player,name=Evoker] run scoreboard players operation @s Relic = @e[name=EvokerStats] Relic
execute as @e[tag=Player,name=Angel] run scoreboard players operation @s Relic = @e[name=AngelStats] Relic
execute as @e[tag=Player,name=Demon] run scoreboard players operation @s Relic = @e[name=DemonStats] Relic
execute as @e[tag=Player,name=Reaper] run scoreboard players operation @s Relic = @e[name=ReaperStats] Relic
execute as @e[tag=Player] at @s run function generate:relic
execute as @e[tag=Player] at @s run function generate:overflow

#Fear bonuses
execute if entity @e[tag=Pos1,tag=FearBonus1] run data modify storage fight:pos1 List prepend value {Effect:22b,Up:9b,Down:10b,Turns:50l}
execute if entity @e[tag=Pos2,tag=FearBonus1] run data modify storage fight:pos2 List prepend value {Effect:22b,Up:9b,Down:10b,Turns:50l}
execute if entity @e[tag=Pos3,tag=FearBonus1] run data modify storage fight:pos3 List prepend value {Effect:22b,Up:9b,Down:10b,Turns:50l}
execute if entity @e[tag=Pos1,tag=FearBonus2] run data modify storage fight:pos1 List prepend value {Effect:22b,Up:3b,Down:4b,Turns:50l}
execute if entity @e[tag=Pos2,tag=FearBonus2] run data modify storage fight:pos2 List prepend value {Effect:22b,Up:3b,Down:4b,Turns:50l}
execute if entity @e[tag=Pos3,tag=FearBonus2] run data modify storage fight:pos3 List prepend value {Effect:22b,Up:3b,Down:4b,Turns:50l}
tag @e[tag=FearBonus1] remove FearBonus1
tag @e[tag=FearBonus2] remove FearBonus2

#Manifested rooms
execute if score Days Counter matches 8.. unless score MissionLocation Mission matches 5.. unless score MissionType Mission matches 5 run function generate:manifested

#Music
execute if score MissionLocation Mission matches 1 run scoreboard players set Playing Music 1
execute if score MissionLocation Mission matches 2 run scoreboard players set Playing Music 2
execute if score MissionLocation Mission matches 3 run scoreboard players set Playing Music 3
execute if score MissionLocation Mission matches 4 run scoreboard players set Playing Music 4
execute if score MissionLocation Mission matches 5 run scoreboard players set Playing Music 5

#Everything else!
tp @a[tag=Playing] -28 4 -28
give @a[tag=!Playing] carrot_on_a_stick{CustomModelData:112,display:{Name:'{"text":"Spectate","color":"#AD6800","italic":"true"}',Lore:['{"text":"Right-click to spectate instead!","color":"gray","italic":"false"}']}}
stopsound @a
kill @e[tag=DeleteDir]
summon villager -28 6 -29 {CustomName:"\"SelectNorth\"",NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],Invulnerable:1}
summon villager -27 4.5 -29 {CustomName:"\"SelectEast\"",NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],Invulnerable:1}
summon villager -29 4.5 -29 {CustomName:"\"SelectWest\"",NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],Invulnerable:1}
summon villager -28 3 -29 {CustomName:"\"SelectSouth\"",NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],Invulnerable:1}
execute at @e[name=WalkMarker] if block ~ ~-1 ~-7 #main:walk run summon armor_stand -28 6 -29 {CustomName:'{"text":"[\\u2191]","color":"green"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] unless block ~ ~-1 ~-7 #main:walk run summon armor_stand -28 6 -29 {CustomName:'{"text":"[\\u2191]","color":"red"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] if block ~7 ~-1 ~ #main:walk run summon armor_stand -27 5 -29 {CustomName:'{"text":"[\\u2192]","color":"green"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] unless block ~7 ~-1 ~ #main:walk run summon armor_stand -27 5 -29 {CustomName:'{"text":"[\\u2192]","color":"red"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] if block ~-7 ~-1 ~ #main:walk run summon armor_stand -29 5 -29 {CustomName:'{"text":"[\\u2190]","color":"green"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] unless block ~-7 ~-1 ~ #main:walk run summon armor_stand -29 5 -29 {CustomName:'{"text":"[\\u2190]","color":"red"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] if block ~ ~-1 ~7 #main:walk run summon armor_stand -28 4 -29 {CustomName:'{"text":"[\\u2193]","color":"green"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
execute at @e[name=WalkMarker] unless block ~ ~-1 ~7 #main:walk run summon armor_stand -28 4 -29 {CustomName:'{"text":"[\\u2193]","color":"red"}',NoAI:1,Silent:1,Tags:["Invisible","DeleteDir"],CustomNameVisible:1,NoGravity:1,Marker:1,Invisible:1}
scoreboard players set @s UseSelect 0
execute positioned -33 4 -32 store result score Hallway Math run data get entity @e[tag=Player,sort=furthest,limit=1] Pos[0]
execute positioned -33 4 -32 store result score Hallway2 Math run data get entity @e[tag=Player,sort=furthest,limit=1] Pos[0]
scoreboard players set Hallway3 Math 0

execute at @e[name=WalkMarker] run function main:calc/scout
execute at @e[name=WalkMarker] run tag @e[name=Room,distance=..2,limit=1] add Scouted

fill -32 4 -31 -32 7 -34 stone replace prismarine
execute if score MissionLocation Mission matches 5 run fill -32 4 -31 -32 7 -34 prismarine replace stone

schedule function generate:inventory 5t
function main:talk/select/mission_start
