#Joining (disabled for devs)
scoreboard players set @a[tag=Dev] Leave 0
execute as @a[tag=!Joined] run function main:join
execute as @a[scores={Leave=1..}] run function main:join
execute unless entity @a[tag=Playing] as @a[limit=1,sort=random] run function main:join
execute as @a[tag=Playing] at @s run tp @a[tag=Spectating] ~ ~ ~
gamemode spectator @a[tag=Spectating]

#Combat
execute if entity @a[tag=InDungeon] run function main:maincombat

#Lobby
execute if entity @a[tag=Lobby] run function lobby:main
effect give @e[type=wandering_trader] invisibility 1 0 true
effect give @e[type=villager,tag=VillagerRelic] invisibility 1 0 true
effect give @e[type=skeleton,name=Morro] invisibility 1 0 true
effect give @e[tag=Invisible] invisibility 1 0 true

#Music
execute if score Playing Music matches 1.. run scoreboard players add Timer Music 1
execute if score Timer Music = LoopTime Music run function main:turnpass/music
scoreboard players operation MusicOld Music = Playing Music
execute unless score MusicOld Music = MusicNew Music run function main:turnpass/music
scoreboard players operation MusicNew Music = Playing Music

#Tutorial
execute if block 27 5 8 stone_button[powered=true] run setblock 27 4 8 black_concrete_powder
execute if block 27 4 8 black_concrete_powder run function main:tutorial
execute as @a[x=16,y=5,z=8,distance=..2] at @s if block ~ ~-1 ~ minecraft:bedrock run tag @a[tag=Playing] remove Playing
execute as @a[x=16,y=5,z=8,distance=..2] at @s if block ~ ~-1 ~ minecraft:bedrock run tag @s add Playing
execute as @a[x=16,y=5,z=8,distance=..2] at @s if block ~ ~-1 ~ minecraft:bedrock run scoreboard players set TutTime Time 0
execute as @a[x=16,y=5,z=8,distance=..2] at @s if block ~ ~-1 ~ minecraft:bedrock run tp @a 17 5 1
execute as @a[x=17,y=5,z=1,distance=..2] unless score Running Cutscene matches 9 run function main:tutorial2

execute as @a[scores={TriggerStartup=1..2}] run scoreboard players set Running Cutscene 6
execute as @a[scores={TriggerStartup=3}] run scoreboard players set Running Cutscene 7
execute as @a[scores={TriggerStartup=4}] run scoreboard players set Running Cutscene 8
execute as @a[scores={TriggerStartup=5}] run scoreboard players enable @s TriggerStartup
execute as @a[scores={TriggerStartup=5}] run tellraw @s ["",{"text":"ARE YOU SURE?          "},{"text":"[Skip it already!]","color":"dark_gray","clickEvent":{"action":"run_command","value":"/trigger TriggerStartup set 6"},"hoverEvent":{"action":"show_text","contents":{"text":"Seriously, don't skip this if you haven't seen it! Last warning.","color":"blue"}}}]
execute as @a[scores={TriggerStartup=6}] run function lobby:mainload
execute as @a[scores={TriggerStartup=7}] run function main:dev/skip_intro
execute as @a[scores={TriggerStartup=8}] run tellraw @s {"text":"Good choice."}
execute as @a[scores={TriggerStartup=5..8}] run scoreboard players set @a TriggerStartup 0

#Dev book introduction
execute as @a[tag=!DevMode,tag=Playing,gamemode=creative] run tellraw @s ["",{"text":"--- Hold up! ---","bold":true,"color":"red"},{"text":"\n"},{"text":"Looks like you entered Creative Mode. That's fine. I always keep my maps accessible.\nHoewever, due to the nature of this map, it may be a little tricky to actually cheat without breaking things.\nSo, here's a \"Dev Book\". You can use it freely to your advantage. Read it carefully! And have fun.","color":"green"},{"text":"\n\n"},{"text":"- Dieuwt","color":"dark_red"}] 
execute as @a[tag=!DevMode,tag=Playing,gamemode=creative] run function main:dev/book
execute as @a[tag=!DevMode,tag=Playing,gamemode=creative] run tag @s add DevMode

#Cutscene skipping
execute as @a[scores={TriggerCutscene=1}] run function main:main_skipcutscene

#Cutscenes
execute if score Running Cutscene matches 1.. if entity @a[tag=Playing] run function main:cutscene/aselect
execute unless score Running Cutscene matches 1.. run gamemode adventure @a[tag=!Playing,gamemode=spectator,tag=!Dev,tag=!Spectating]

#General
effect give @e resistance 5 10 true
effect give @a saturation 5 10 true
effect give @a weakness 5 10 true
effect give @e fire_resistance 5 10 true
execute as @e[type=enderman,tag=Enemy] at @s run setblock ~ ~2 ~ air destroy
kill @e[type=slime,tag=!Enemy,tag=!LobbyTalker]
kill @e[type=magma_cube,tag=!Enemy]
tp @e[type=#main:spawner,tag=!Enemy,tag=!LobbyTalker] ~ -200 ~
kill @e[type=#main:spawner,tag=!Enemy,tag=!LobbyTalker]
kill @e[type=item,nbt={Item:{id:"minecraft:music_disc_wait"}}]
execute as @e[tag=Enemy,tag=!LootAdjust] run data merge entity @s {DeathLootTable:"invalid"}
tag @e[tag=Enemy,tag=!LootAdjust] add LootAdjust

tag @e[type=item,tag=!RelicItem,nbt={Item:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:102,Player:1s,Enemy:0s}}}] add RetreatItem
execute as @e[type=item,tag=!RelicItem,tag=!RetreatItem,nbt=!{Item:{id:"minecraft:music_disc_mall"}}] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,tag=!RelicItem,tag=RetreatItem2] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,tag=!RelicItem,tag=RetreatItem,tag=!RetreatItem2] run data merge entity @s {PickupDelay:2}
tag @e[type=item,tag=!RelicItem,nbt={Item:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:102,Player:1s,Enemy:0s}}}] add RetreatItem2

xp set @a 0 levels
xp set @a 0 points
clear @a[gamemode=!creative] barrier
clear @a[gamemode=!creative] honeycomb
kill @e[type=tnt,nbt={Fuse:5s}]
effect clear @a[tag=Playing,tag=!Lobby] invisibility
effect give @a[tag=!Playing,tag=!Dev] invisibility 1000000 0 true

#Effects
scoreboard players add @e[name=Demon] Counter 1
execute as @e[name=Demon,scores={Counter=3..},tag=!Camping] at @s run summon area_effect_cloud ^0.4 ^1.5 ^ {Tags:["DemonParticle"],Duration:3,CustomName:"\"DemonParticle1\"",Rotation:[-90.0f,0.0f]}
execute as @e[name=Demon,scores={Counter=3..},tag=!Camping] at @s run summon area_effect_cloud ^-0.4 ^1.5 ^ {Tags:["DemonParticle"],Duration:3,CustomName:"\"DemonParticle2\"",Rotation:[-90.0f,0.0f]}
execute as @e[name=DemonParticle1] store result score @s Math run data get entity @e[name=Demon,limit=1] Pose.LeftArm[0]
execute as @e[name=DemonParticle2] store result score @s Math run data get entity @e[name=Demon,limit=1] Pose.RightArm[0]
execute as @e[tag=DemonParticle] run scoreboard players add @s Math 90
execute as @e[tag=DemonParticle] store result entity @s Rotation[1] float 1 run scoreboard players get @s Math
execute as @e[tag=DemonParticle] store result entity @s Rotation[0] float 1 run data get entity @e[name=Demon,limit=1] Rotation[0]
execute as @e[tag=DemonParticle] run scoreboard players set @s Math 0
execute as @e[tag=DemonParticle] at @s anchored eyes rotated as @s positioned ~ ~ ~ run function main:use/demon/particle
execute as @e[name=Demon,scores={Counter=3..}] run scoreboard players set @s Counter 0
execute as @e[name=Reaper,tag=!NoDeathEffect] at @s run particle smoke ~ ~0.5 ~ 0.2 0.5 0.2 0.01 10 force
execute as @e[name=Death,tag=!NoDeathEffect] at @s run particle smoke ~ ~0.5 ~ 0.2 0.5 0.2 0.01 30 force
execute at @e[type=skeleton,name=Morro] run particle smoke ~ ~0.2 ~ 0.2 0.6 0.2 0.01 20 force
execute as @e[name=Spectre] at @s run particle cloud ~ ~0.5 ~ 0.1 0.2 0.1 0.01 4 force
execute as @e[name="Master Grey"] at @s run particle dust 0.1 0.1 0.1 1 ~ ~ ~ 0.3 0.8 0.3 0.01 40 force
execute as @e[name="The Lich"] at @s run particle mycelium ~ ~1 ~ 0.5 2 0.5 0.01 90 force
execute as @e[name="Air Unit"] at @s run particle cloud ~ ~1 ~1 0.8 1.3 1.3 0.01 3 force
execute as @e[name="Smoke Unit"] at @s run particle smoke ~ ~1 ~ 0.3 1.3 0.3 0.01 20 force