#Reflex
execute as @e[tag=Enemy,name="Arch Angel"] if entity @e[tag=Player,name=Angel,scores={Health=..10}] run tag @s add ReflexActive
execute as @e[tag=Enemy,name="Arch Angel"] if entity @e[tag=Player,name=Angel,scores={Health=..10}] run tag @s add ActNow

scoreboard players remove @e[tag=OnTurn] Turns 1
execute if entity @e[tag=DevInfinite,tag=Playing] run scoreboard players add @e[tag=OnTurn] Turns 1
scoreboard players add @e[tag=ReflexActive,scores={Turns=0}] Turns 1

execute unless entity @e[tag=InField,scores={Turns=1..}] run function main:turnpass/newround

#Debug: force player/enemy loops
#scoreboard players set @e[tag=Player] Turns 1
#scoreboard players set @e[tag=Enemy] Turns 1

#Base Speed
scoreboard players set SpeedMod RNG 5
execute as @e[tag=InField] run scoreboard players operation @s SpeedTurn = @s Speed
execute as @e[tag=InField] run function main:calc/speed

#Modified Speed
execute as @e[tag=InField] run function main:stats/speed
execute as @e[tag=InField,scores={Overflow=9}] run scoreboard players add @s SpeedTurn 2

##Add 100 for increased range (I... think)
scoreboard players add @e[tag=InField] SpeedTurn 100
##Weary units have low priority
scoreboard players remove @e[scores={EffectActL=1..},tag=InField] SpeedTurn 100
##Alert units have high priority
scoreboard players add @e[scores={EffectActF=1..},tag=InField] SpeedTurn 100
#Dev tool: infinite turns (still outpaced by Reflexes)
execute if entity @e[tag=DevInfinite,tag=Playing] run scoreboard players add @e[tag=OnTurn] SpeedTurn 100
##Ruby: attempt to act first
scoreboard players add @e[tag=ActRuby,tag=InField] SpeedTurn 200
##Emerald: attempt to act first, then last
scoreboard players add @e[tag=ActEmerald,tag=InField,scores={Turns=2..}] SpeedTurn 200
scoreboard players remove @e[tag=ActEmerald,tag=InField,scores={Turns=1}] SpeedTurn 200
##Sapphire: attempt to act last
scoreboard players remove @e[tag=ActSapphire,tag=InField] SpeedTurn 200
##No-turned units have lowest priority: cannot act
scoreboard players set @e[tag=Turnless] Turns 0
scoreboard players set @e[scores={Turns=..0}] SpeedTurn -1000
##Dead enemies have higher priority: immediate death
scoreboard players set @e[scores={Health=..0,EffectUndying=0},tag=Enemy] SpeedTurn 1000
scoreboard players set @e[scores={Health=..0,EffectUndying=0},tag=PlayerFake] SpeedTurn 1000
#Reflex activates at the highest possible priority (can revive "dead" enemies)
scoreboard players add @e[tag=ReflexActive] SpeedTurn 10000
tag @e[tag=ReflexActive] remove ReflexActive
##Who has the highest speed?
scoreboard players set Highest SpeedTurn -999
execute as @e[tag=InField] run scoreboard players operation Highest SpeedTurn > @s SpeedTurn
execute as @e[tag=InField] run scoreboard players operation @s SpeedTurn -= Highest SpeedTurn

#A boss that just was on turn, cannot be on turn again.
execute as @e[tag=Boss,tag=OnTurn,tag=!ActRuby,tag=!ActSapphire] run tag @s add NoDoubles

tag @e[tag=OnTurn] remove OnTurn

#If there's 1 player with 1 turn and the boss has 2 turns, the boss has priority.
execute as @e[scores={Turns=0},limit=1] at @s if entity @e[scores={Turns=0},distance=2..12] run tag @e[tag=Enemy,scores={Turns=2..},limit=1,sort=random,tag=!NoDoubles] add OnTurn

#Take the one with the highest Speed roll.
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=0},limit=1,sort=random,tag=!NoDoubles] add OnTurn

#If there's still nobody on turn (double boss turns), simply go up until you find someone with a high roll.
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-1},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-2},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-3},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-4},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-5},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-6},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-7},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-8},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-9},limit=1,sort=random,tag=!NoDoubles] add OnTurn
execute unless entity @e[tag=OnTurn] run tag @e[tag=InField,scores={SpeedTurn=-10},limit=1,sort=random,tag=!NoDoubles] add OnTurn

execute as @e[tag=Player,tag=OnTurn] run tag @e[tag=LastActed] remove LastActed
execute as @e[tag=Player,tag=OnTurn,limit=1,sort=random] run tag @s add LastActed
tag @e[tag=NoDoubles] remove NoDoubles

execute as @e[tag=InField] run scoreboard players operation @s SpeedTurn += Highest SpeedTurn